
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#中的异步调用及异步设计模式(二)——基于 IAsyncResult 的异步设计模式 / 憋错料</title>

    <meta name="description" content="C#中的异步调用及异步设计模式(二)——基于 IAsyncResult 的异步设计模式 三.基于 IAsyncResult 的异步设计模式(设计层面) IAsyncResult 异步设计模式通过名为 BeginOperationName 和 EndOperationName 的两个方法来实现原同步方法的异步调用,如 FileStream 类提供了 BeginRead 和 EndRead 方法来从文件异步读取字节,它们是 Read 方法的异步版本 Begin 方法包含同步方法签名中的任何参数,此外还包含另外两个参数:一个AsyncCallback 委托和一个用户定义的状态对象.委托用">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#中的异步调用及异步设计模式(二)——基于 IAsyncResult 的异步设计模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>三、基于 IAsyncResult 的异步设计模式（设计层面）</strong></p>
<p>IAsyncResult 异步设计模式通过名为 BeginOperationName 和 EndOperationName 的两个方法来实现原同步方法的异步调用，如 FileStream 类提供了 BeginRead 和 EndRead 方法来从文件异步读取字节，它们是 Read 方法的异步版本</p>
<p>Begin 方法包含同步方法签名中的任何参数，此外还包含另外两个参数：一个AsyncCallback 委托和一个用户定义的状态对象。委托用来调用回调方法，状态对象是用来向回调方法传递状态信息。该方法返回一个实现 IAsyncResult 接口的对象</p>
<p>End 方法用于结束异步操作并返回结果，因此包含同步方法签名中的 ref 和 out 参数，返回值类型也与同步方法相同。该方法还包括一个 IAsyncResult 参数，用于获取异步操作是否完成的信息，当然在使用时就必须传入对应的 Begin 方法返回的对象实例</p>
<p>开始异步操作后如果要阻止应用程序，可以直接调用 End 方法，这会阻止应用程序直到异步操作完成后再继续执行。也可以使用 IAsyncResult 的 AsyncWaitHandle 属性，调用其中的WaitOne等方法来阻塞线程。这两种方法的区别不大，只是前者必须一直等待而后者可以设置等待超时</p>
<p>如果不阻止应用程序，则可以通过轮循 IAsyncResult 的 IsCompleted 状态来判断操作是否完成，或使用 AsyncCallback 委托来结束异步操作。AsyncCallback 委托包含一个 IAsyncResult 的签名，回调方法内部再调用 End 方法来获取操作执行结果</p>
<p><strong>[csharp]</strong> <a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>public&nbsp;class&nbsp;AsyncDemo</li>
<li>{</li>
<li>//&nbsp;Use&nbsp;in&nbsp;asynchronous&nbsp;methods</li>
<li>private&nbsp;delegate&nbsp;string&nbsp;runDelegate();</li>
<li>private&nbsp;string&nbsp;m_Name;</li>
<li>private&nbsp;runDelegate&nbsp;m_Delegate;</li>
<li>public&nbsp;AsyncDemo(string&nbsp;name)</li>
<li>{</li>
<li>m_Name&nbsp;=&nbsp;name;</li>
<li>m_Delegate&nbsp;=&nbsp;new&nbsp;runDelegate(Run);</li>
<li>}</li>
<li>public&nbsp;string&nbsp;Run()</li>
<li>{</li>
<li>return&nbsp;"My&nbsp;name&nbsp;is&nbsp;"&nbsp;+&nbsp;m_Name;</li>
<li>}</li>
<li>public&nbsp;IAsyncResult&nbsp;BeginRun(AsyncCallback&nbsp;callBack,&nbsp;Object&nbsp;stateObject)</li>
<li>{</li>
<li>try</li>
<li>{</li>
<li>return&nbsp;m_Delegate.BeginInvoke(callBack,&nbsp;stateObject);</li>
<li>}</li>
<li>catch&nbsp;(Exception&nbsp;e)</li>
<li>{</li>
<li>//&nbsp;Hide&nbsp;inside&nbsp;method&nbsp;invoking&nbsp;stack</li>
<li>throw&nbsp;e;</li>
<li>}</li>
<li>}</li>
<li>public&nbsp;string&nbsp;EndRun(IAsyncResult&nbsp;ar)</li>
<li>{</li>
<li>if&nbsp;(ar&nbsp;==&nbsp;null)</li>
<li>throw&nbsp;new&nbsp;NullReferenceException("Arggument&nbsp;ar&nbsp;can‘t&nbsp;be&nbsp;null");</li>
<li>try</li>
<li>{</li>
<li>return&nbsp;m_Delegate.EndInvoke(ar);</li>
<li>}</li>
<li>catch&nbsp;(Exception&nbsp;e)</li>
<li>{</li>
<li>//&nbsp;Hide&nbsp;inside&nbsp;method&nbsp;invoking&nbsp;stack</li>
<li>throw&nbsp;e;</li>
<li>}</li>
<li>}</li>
<li>}</li>
</ol>
<p>首先是 Begin 之后直接调用 End 方法，当然中间也可以做其他的操作</p>
<p><strong>[csharp]</strong> <a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>class&nbsp;AsyncTest</li>
<li>{</li>
<li>static&nbsp;void&nbsp;Main(string[]&nbsp;args)</li>
<li>{</li>
<li>AsyncDemo&nbsp;demo&nbsp;=&nbsp;new&nbsp;AsyncDemo("jiangnii");</li>
<li>//&nbsp;Execute&nbsp;begin&nbsp;method</li>
<li>IAsyncResult&nbsp;ar&nbsp;=&nbsp;demo.BeginRun(null,&nbsp;null);</li>
<li>//&nbsp;You&nbsp;can&nbsp;do&nbsp;other&nbsp;things&nbsp;here</li>
<li>//&nbsp;Use&nbsp;end&nbsp;method&nbsp;to&nbsp;block&nbsp;thread&nbsp;until&nbsp;the&nbsp;operation&nbsp;is&nbsp;complete</li>
<li>string&nbsp;demoName&nbsp;=&nbsp;demo.EndRun(ar);</li>
<li>Console.WriteLine(demoName);</li>
<li>}</li>
<li>}</li>
</ol>
<p>也可以用 IAsyncResult 的 AsyncWaitHandle 属性，我在这里设置为1秒超时</p>
<p><strong>[csharp]</strong> <a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>class&nbsp;AsyncTest</li>
<li>{</li>
<li>static&nbsp;void&nbsp;Main(string[]&nbsp;args)</li>
<li>{</li>
<li>AsyncDemo&nbsp;demo&nbsp;=&nbsp;new&nbsp;AsyncDemo("jiangnii");</li>
<li>//&nbsp;Execute&nbsp;begin&nbsp;method</li>
<li>IAsyncResult&nbsp;ar&nbsp;=&nbsp;demo.BeginRun(null,&nbsp;null);</li>
<li>//&nbsp;You&nbsp;can&nbsp;do&nbsp;other&nbsp;things&nbsp;here</li>
<li>//&nbsp;Use&nbsp;AsyncWaitHandle.WaitOne&nbsp;method&nbsp;to&nbsp;block&nbsp;thread&nbsp;for&nbsp;1&nbsp;second&nbsp;at&nbsp;most</li>
<li>ar.AsyncWaitHandle.WaitOne(1000,&nbsp;false);</li>
<li>if&nbsp;(ar.IsCompleted)</li>
<li>{</li>
<li>//&nbsp;Still&nbsp;need&nbsp;use&nbsp;end&nbsp;method&nbsp;to&nbsp;get&nbsp;result,&nbsp;but&nbsp;this&nbsp;time&nbsp;it&nbsp;will&nbsp;return&nbsp;immediately</li>
<li>string&nbsp;demoName&nbsp;=&nbsp;demo.EndRun(ar);</li>
<li>Console.WriteLine(demoName);</li>
<li>}</li>
<li>else</li>
<li>{</li>
<li>Console.WriteLine("Sorry,&nbsp;can‘t&nbsp;get&nbsp;demoName,&nbsp;the&nbsp;time&nbsp;is&nbsp;over");</li>
<li>}</li>
<li>}</li>
<li>}</li>
</ol>
<p>不中断的轮循，每次循环输出一个 "."</p>
<p><strong>[csharp]</strong> <a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>class&nbsp;AsyncTest</li>
<li>{</li>
<li>static&nbsp;void&nbsp;Main(string[]&nbsp;args)</li>
<li>{</li>
<li>AsyncDemo&nbsp;demo&nbsp;=&nbsp;new&nbsp;AsyncDemo("jiangnii");</li>
<li>//&nbsp;Execute&nbsp;begin&nbsp;method</li>
<li>IAsyncResult&nbsp;ar&nbsp;=&nbsp;demo.BeginRun(null,&nbsp;null);</li>
<li>Console.Write("Waiting..");</li>
<li>while&nbsp;(!ar.IsCompleted)</li>
<li>{</li>
<li>Console.Write(".");</li>
<li>//&nbsp;You&nbsp;can&nbsp;do&nbsp;other&nbsp;things&nbsp;here</li>
<li>}</li>
<li>Console.WriteLine();</li>
<li>//&nbsp;Still&nbsp;need&nbsp;use&nbsp;end&nbsp;method&nbsp;to&nbsp;get&nbsp;result,&nbsp;but&nbsp;this&nbsp;time&nbsp;it&nbsp;will&nbsp;return&nbsp;immediately</li>
<li>string&nbsp;demoName&nbsp;=&nbsp;demo.EndRun(ar);</li>
<li>Console.WriteLine(demoName);</li>
<li>}</li>
<li>}</li>
</ol>
<p>最后是使用回调方法并加上状态对象，状态对象被作为 IAsyncResult 参数的 AsyncState<br />
属性被传给回调方法。回调方法执行前不能让主线程退出，我这里只是简单的让其休眠了1秒。另一个与之前不同的地方是 AsyncDemo<br />
对象被定义成了类的静态字段，以便回调方法使用</p>
<p><strong>[csharp]</strong> <a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">view plain</a><a href="http://blog.csdn.net/zztfj/article/details/6823362" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>class&nbsp;AsyncTest</li>
<li>{</li>
<li>static&nbsp;AsyncDemo&nbsp;demo&nbsp;=&nbsp;new&nbsp;AsyncDemo("jiangnii");</li>
<li>static&nbsp;void&nbsp;Main(string[]&nbsp;args)</li>
<li>{</li>
<li>//&nbsp;State&nbsp;object</li>
<li>bool&nbsp;state&nbsp;=&nbsp;false;</li>
<li>//&nbsp;Execute&nbsp;begin&nbsp;method</li>
<li>IAsyncResult&nbsp;ar&nbsp;=&nbsp;demo.BeginRun(new&nbsp;AsyncCallback(outPut),&nbsp;state);</li>
<li>//&nbsp;You&nbsp;can&nbsp;do&nbsp;other&nbsp;thins&nbsp;here</li>
<li>//&nbsp;Wait&nbsp;until&nbsp;callback&nbsp;finished</li>
<li>System.Threading.Thread.Sleep(1000);</li>
<li>}</li>
<li>//&nbsp;Callback&nbsp;method</li>
<li>static&nbsp;void&nbsp;outPut(IAsyncResult&nbsp;ar)</li>
<li>{</li>
<li>bool&nbsp;state&nbsp;=&nbsp;(bool)ar.AsyncState;</li>
<li>string&nbsp;demoName&nbsp;=&nbsp;demo.EndRun(ar);</li>
<li>if&nbsp;(state)</li>
<li>{</li>
<li>Console.WriteLine(demoName);</li>
<li>}</li>
<li>else</li>
<li>{</li>
<li>Console.WriteLine(demoName&nbsp;+&nbsp;",&nbsp;isn‘t&nbsp;it?");</li>
<li>}</li>
<li>}</li>
<li>}</li>
</ol>
<p>对于一个已经实现了 BeginOperationName 和 EndOperationName<br />
方法的对象，我们可以直接用上述方式调用，但对于只有同步方法的对象，我们要对其进行异步调用也不需要增加对应的异步方法，而只需定义一个委托并使用其<br />
BeginInvoke 和 EndInvoke 方法就可以了</p>
<p><strong>四、基于事件的异步模式（设计层面）</strong></p>
<p>待续...</p>
<p><P>C#中的异步调用及异步设计模式(二)——基于 IAsyncResult 的异步设计模式</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-01 19:13:25 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#中的异步调用及异步设计模式(二)——基于 IAsyncResult 的异步设计模式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vAPwo0.html" rel="bookmark">C&num;中的异步调用及异步设计模式&lpar;三&rpar;&mdash;&mdash;基于事件的异步模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				四.基于事件的异步模式(设计层面) 基于事件的C#异步编程模式是比IAsyncResult模式更高级的一种异步编程模式,也被用在更多的场合.该异步模式具有以下优点: ·                  “在后台”执行耗时任务(例如下载和数据库操作),但不会中断您的应用程序. ·                  同时执行多个操作,每个操作完成时都会接到通知(在通知中可以区分是完成了哪个操作). ·                  等待资源变得可用,但不会停止(“挂起”)您的应用程序. ·  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPZp1n3.html" rel="bookmark">&lbrack;转载&rsqb;C&num;异步调用四大方法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C#异步调用四大方法是什么呢?C#异步调用四大方法的使用是如何进行的呢?让我们首先了解下什么时候用到C#异步调用: .NET Framework 允许您C#异步调用任何方法.定义与您需要调用的方法具有相同签名的委托:公共语言运行库将自动为该委托定义具有适当签名的 BeginInvoke 和 EndInvoke 方法. BeginInvoke 方法用于启动C#异步调用.它与您需要异步执行的方法具有相同的参数,只不过还有两个额外的参数(将在稍后描述).BeginInvoke 立即返回,不等待C#异步			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l9lpP3.html" rel="bookmark">&period;Net组件程序设计之异步调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				.Net组件程序设计之异步调用 说到异步调用,在脑海中首先想到就是BeginInvoke(),在一些常用对象中我们也会常常见到Invoke()和BeginInvoke(), 要想让自己的组件可以被客户端调用或者是异步调用,这样的设计是合理的,这也是组件异步机制当中的一条 (说句题外话--其实大多数知识都隐藏在我们平时经常见到的对象或者是代码里,只不过是没有去细心的发现) 在.NET中首先就会想到使用委托来进行异步调用,关于委托的定义在 委托与事件一文中已经大概的说过了,文中只是对委托进行了 大概			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgqbVO3.html" rel="bookmark">C&num; 委托的同步调用和异步调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				委托的Invoke方法用来进行同步调用.同步调用也可以叫阻塞调用,它将阻塞当前线程,然后执行调用,调用完毕后再继续向下进行. 同步调用的例子: using System; using System.Threading; public delegate int AddHandler(int a, int b); public class Foo { static void Main() { Console.WriteLine(&quot;**********SyncInvokeTest***********			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qkVbGM.html" rel="bookmark">客户端的异步调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C#客户端的异步操作 阅读目录 开始 示例项目介绍 同步调用服务 异步接口介绍 1. 委托异步调用 2. 使用IAsyncResult接口实现异步调用 3. 基于事件的异步调用模式 4. 创建新线程的异步方式 5. 使用线程池的异步方式 6. 使用BackgroundWorker实现异步调用 客户端的其它代码 各种异步方式的优缺点 异步文件I/O操作 数据库的异步操作 异步设计的使用总结 在Asp.net中使用异步 上篇博客[用Asp.net写自己的服务框架] 我讲述了如何实现自己的服务框架,但			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGxo8Y0.html" rel="bookmark">C&num;：Func的同步、异步调用&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				实际开发中,对于一些耗时较长的操作,我们往往会将其封装成异步方式调用,以加速系统响应或改善用户体验,下面是一个示例: 有一个现成的类MyMath,里面有一个Add方法: 1 public class MyMath 2 { 3 4 public int Add(int a, int b) 5 { 6 System.Threading.Thread.Sleep(5000); 7 return a + b; 8 } 9 10 } 对Add方法做下封装,对了对比,同时提供“同步调用”与&quot;异步调用&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bzez90.html" rel="bookmark">C&num;  同步调用  异步调用  异步回调  多线程的作用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				同步调用   : 委托的Invoke方法用来进行同步调用.同步调用也可以叫阻塞调用,它将阻塞当前线程,然后执行调用,调用完毕后再继续向下进行. 异步调用  :同步调用会阻塞线程,如果是要调用一项繁重的工作(如大量IO操作),可能会让程序停顿很长时间,造成糟糕的用户体验,这时候异步调用就很有必要了.异步调用不阻塞线程,而是把调用塞到线程池中,程序主线程或UI线程可以继续执行.委托的异步调用通过BeginInvoke和EndInvoke来实现. 异步回调函数  :当异步调用时,主线程并没有等待,而是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLmkBd0.html" rel="bookmark">谈&period;Net委托与线程&mdash;&mdash;创建无阻塞的异步调用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本文大部分内容来自于mikeperetz的Asynchronous Method Invocation及本人的一些个人体会所得,希望对你有所帮助.原英文文献可以在codeproject中搜索到. 介绍 这篇文章将介绍异步调用的实现机制及如何调用异步方法.大多数.NET开发者在经过delegate.Thread.AsynchronousInvocation之后,通常都会对以上概念产生混淆及误用.实际上,以上概念是.NET2.0版本中对并行编程的核心支持,基于概念上的错误认识有可能导致在实际的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzrqOlM.html" rel="bookmark">谈&period;Net委托与线程&mdash;&mdash;创建无阻塞的异步调用&lpar;一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 本文大部分内容来自于mikeperetz的Asynchronous Method Invocation及本人的一些个人体会所得,希望对你有所帮助.原英文文献可以在codeproject中搜索到. 介绍 这篇文章将介绍异步调用的实现机制及如何调用异步方法.大多数.NET开发者在经过delegate.Thread.AsynchronousInvocation之后,通常都会对以上概念产生混淆及误用.实际上,以上概念是.NET2.0版本中对并行编程的核心支持,基于概念上的错误认识有可能导致在实际的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/QM6Qyv4.html" rel="bookmark" class="title">javaWeb笔记：gson</a>
					<div>
						谷歌的Gson.jar: //list转换为json Gson gson = new Gson(); List&lt;Person&gt; persons = new ArrayList&lt;Per ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMz7JW0.html" rel="bookmark" class="title">hibernate 中根据id删除一条记录的语句</a>
					<div>
						qid name like content 1 A 1 the first text 2 B 2 the Second text 1 C 3 the Third text 如上表所示,当我们需要某个q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MExaK4.html" rel="bookmark" class="title">ZOJ3201&lpar;树形DP&rpar;</a>
					<div>
						Tree of Tree Time Limit: 1 Second      Memory Limit: 32768 KB You're given a tree with weights of ea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmleGK4.html" rel="bookmark" class="title">大话IS08583报文协议</a>
					<div>
						背景 最近在学习ISO8583报文协议, 苦于网上只有些苦涩难懂的中文翻译解释, 和由于自己蹩脚的英语看不懂国外资料, 在搜寻一翻后, 查到了一些资料,  特此整理出来.. 正文 如果单纯的讲IS08 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZY9VZ0.html" rel="bookmark" class="title">HTML之总结</a>
					<div>
						基础结构 基础标签有HTML,head,body. 合格的的HTML页面: &lt;!DOCTYPE html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;hea ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aDDPgM.html" rel="bookmark" class="title">【CSS基础】琐碎记录&amp;lt&semi;三&amp;gt&semi;</a>
					<div>
						关于属性 vertical-align 今天出现一个问题,table里面的一个单元格有一个text类型的input,然后有一张图片.我搞了很久,图片不能垂直居中,我把input去掉,发现自适应又居中了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYWLVM.html" rel="bookmark" class="title">第五届蓝桥杯练习题 - 入门练习Java解题代码</a>
					<div>
						&gt;&gt;入门训练 圆的面积 时间限制:1.0s   内存限制:256.0MB 锦囊1 锦囊2 锦囊3 问题描述 给定圆的半径r,求圆的面积. 输入格式 输入包含一个整数r,表示圆的半径. 输出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZDZPqM.html" rel="bookmark" class="title">复制文件时，如何显示进度条（使用BlockRead函数读取数据，并插入application&period;ProcessMessages）</a>
					<div>
						procedure mycopyfile(sourcef,targetf:string;i:integer); var FromF,ToF:file; NumRead,NumWritten:Integ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qavYD3.html" rel="bookmark" class="title">android studio gradle plugin 用户指南 选择性翻译</a>
					<div>
						原文 http://tools.android.com/tech-docs/new-build-system/user-guide 构建文件 build.gradle Basic Project 1. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZbpzG3.html" rel="bookmark" class="title">POJ--1679--The Unique MST【推断MST是否唯一】</a>
					<div>
						链接:http://poj.org/problem? id=1679 题意:告诉你有n个点,m条边,以及m条边的信息(起点.终点.权值).推断最小生成树是否唯一 之前是用另外一种方法做的.复杂度最高可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdJOP0.html" rel="bookmark" class="title">Oracle数据库配置方式二--使用Net Manager配置数据库</a>
					<div>
						在Oracle安装配置中使用Net Configuration配置了数据库,今天给大家介绍第二种配置方式,Net Manager配置. 先找到我们的Net Manager的快捷方式,如下面截图 这个就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGRZvY4.html" rel="bookmark" class="title">挚字侠又潘l8uymhpyta09672lhlpj</a>
					<div>
						http://3188.la/article/?aid=56290fc263419857c4705654http://3188.la/article/?aid=5629031463419857c470 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGdl7y0.html" rel="bookmark" class="title">推荐系统的循序进阶读物（从入门到精通）</a>
					<div>
						转载一篇文章,作为记录,有时间去看一遍- 为了方便大家从理论到实践,从入门到精通,循序渐进系统地理解和掌握推荐系统相关知识.特做了个读物清单.大家可以按此表阅读,也欢迎提出意见和指出未标明的经典文献以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41DpPO3.html" rel="bookmark" class="title">MySQL数据库管理（二）单机环境下MySQL Cluster的安装</a>
					<div>
						上文&lt;MySQL数据库管理(一)MySQL Cluster集群简单介绍&gt;对MySQL Cluster集群做了简要介绍.本文将教大家一步步搭建单机环境下的MySQL数据库集群. 一.单机环境 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezqxb3.html" rel="bookmark" class="title">schtasks在win7下提示错误&colon;无法加载列资源</a>
					<div>
						转自: http://blog.chinaunix.net/uid-24946452-id-2887851.html 查看cmd 编码 chcp 如使用 936中文GBK编码的话 schtasks.e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d2kNz4.html" rel="bookmark" class="title">UIImage加载本地图片的两种方式</a>
					<div>
						UIImage加载图片方式一般有两种: (1)imagedNamed初始化:默认加载图片成功后会内存中缓存图片,这个方法用一个指定的名字在系统缓存中查找并返回一个图片对象.如果缓存中没有找到相应的图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GOXv0.html" rel="bookmark" class="title">MAC上的Terminal光标快捷键</a>
					<div>
						在Mac系统中并没有Home.End等键,所以在使用时并不是特别的顺手,但是有几个键位组合可以使Terminal的操作更加灵活方便. 1.将光标移动到行首:ctrl + a 2.将光标移动到行尾:ct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6ONv3.html" rel="bookmark" class="title">Leetcode 细节实现题 Spiral Matrix II</a>
					<div>
						Spiral Matrix II Total Accepted: 12773 Total Submissions: 41526My Submissions Given an integer n, ge ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEqmnXM.html" rel="bookmark" class="title">linux文件上传</a>
					<div>
						租了个服务器,要把自己打的war包打上去发布,服务器是linux的(本机是mac).以前都是用wget命令,把需要上传的东西先放到github上面再在服务器上用wget命令下载.最近不知道什么原因,w ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZeEPm0.html" rel="bookmark" class="title">用IPhone6s的3D Touch来称重，比较2个物体的重量</a>
					<div>
						这是一款开源应用,它利用 iPhone 6s 的 3D Touch 屏幕来测量出物体和手机的可能最大力值的相对比.用户还可以选择让 3D Touch 来测量其他物体的相对重量,只要它不超过 iPhon ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
